--=========================================================
--
-- 循環乱数
--
--=========================================================

CirculateRandom = {}
CirculateRandom.new = function ( params )
	
	local this = {}
	this.className = "CirculateRandom"
	this.params = paramas
	
	this.min = params.min
	this.max = params.max
	this.circulateTimes = params.times
	
	this.lot = {}
	
	for i = 1, this.circulateTimes, 1 do
		for n = this.min, this.max, 1 do
			this.lot [ #this.lot + 1 ] = n
		end
	end

	this.currentIndex = #this.lot -- 初回でシャッフルを起こすように

	--=========================================================
	-- シャッフル
	--=========================================================
	this.shuffle = function (self)
		
		for i = #self.lot, 1, -1 do
			
			local j = math.random(1,i)
			
			local temp = self.lot[i]
			self.lot[i] = self.lot[j]
			self.lot[j] = temp
		end
	end
	
	
	--=========================================================
	-- 取得
	--=========================================================
	this.get = function (self)

		self.currentIndex = self.currentIndex + 1
		if ( self.currentIndex > #self.lot ) then
			self.currentIndex = 1
			self:shuffle()
		end
		
		local result = self.lot [ self.currentIndex ]
		return result
	end
	
	
	return this
end
 

