

FeatMonitor_allAreaClear_noMiss = {}
FeatMonitor_allAreaClear_noMiss.new = function ( params )
	
	local this = {}
	this.className = "FeatMonitor_allAreaClear_noMiss"
	this.params = paramas
	
	this.featId = "allAreaClear_noMiss"
	this.featName = "全エリアノーミスクリア"
	this.description = "CHALLENGE MODE で残機を失わずに全"..areaA_last.. "エリアをクリア。"

	this.currentLeft = 0
	this.prevLeft    = 0
	this.isNomiss = true
		
	this.isAchieved = false
	
	--=========================================================
	-- 条件フラグリセット
	--=========================================================
	this.reset = function (self)
		self.currentLeft = 0
		self.prevLeft    = 0
		self.isNomiss = true
	end
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isAchieved ) then
			return
		end
		
		if ( mode ~= "endless" ) then return end

		self.prevLeft = self.currentLeft
		self.currentLeft = #left
--		self.currentLeft = left
		
		if ( self.currentLeft < self.prevLeft ) then
			self.isNomiss = false
		end
		
		if ( self.isNomiss ) then
			if ( phase == "stageClear" and areaA >= areaA_last and areaB == 4) then
				self.isAchieved = true
				setFeatAchievedMessage ( self )
			end
		end
		
	end
	
	
	return this
end
 

