

FeatMonitor_allOnigirisDelivered = {}
FeatMonitor_allOnigirisDelivered.new = function ( params )
	
	local this = {}
	this.className = "FeatMonitor_allOnigirisDelivered"
	this.params = paramas
	
	this.featId = "allOnigirisDelivered"
	this.featName = "全おにぎり配布"
	this.description = "STORY MODEの全ステージで全てのおにぎりを一度も外さずに使い切る。"
	
	this.currentState = { area = 1 }
	this.prevState = { area = 1 }
	
	this.isOnigiriMissed = false
	this.isOnigiriLeftOver = false
	
	this.isAchieved = false
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isAchieved ) then
			return
		end
		
		if ( mode ~= "story" ) then return end
		if ( self.isOnigiriMissed ) then return end
		if ( self.isOnigiriLeftOver ) then return end
		
		-- おにぎり外し判定
		if ( isOnigiriMissed ) then self.isOnigiriMissed = true end
		
		-- おにぎり余剰判定
		if ( phase == "stageClear" ) then

			if ( goodWillLeft > 0) then 
				self.isOnigiriLeftOver = true 
			else
				
				-- ステージ5なら達成
				if ( stage == 5 ) then
					self.isAchieved = true
					setFeatAchievedMessage ( self )
				end
				
			end
		end
		
		
	end
	

	
	return this
end
 

