Star = {}
Star.new = function ( params )
	
	local this = {}
	this.className = "Star"
	this.params = paramas
	
	this.x = math.random ( WIDTH )
	this.y = math.random ( HEIGHT )
	
	this.size = math.random ( 1,2 )
	
	local speeds = { 0.4, 1.0 }
	this.speed = speeds[this.size] + math.random(0, 5) * 0.1

	local brights = { 0.5, 0.6 }
	this.bright = brights[this.size]
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		self.y = self.y + self.speed
		if ( self.y > HEIGHT + 10 ) then
			self.y = -10
		end
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)
	
		local r,g,b,a = love.graphics.getColor()
		love.graphics.setColor ( self.bright, self.bright, self.bright, 1.0 )
		love.graphics.rectangle( "fill", self.x, self.y, self.size * 2, self.size * 2)
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

